
# uncomment to disable foreman-generate-answers script (and dependencies)
#global skip_generator 1

%if "%{?scl}" == "ruby193"
    %global scl_prefix %{scl}-
    %global scl_ruby /usr/bin/ruby193-ruby
%else
    %global scl_ruby /usr/bin/ruby
%endif

# set and uncomment all three to set alpha tag
%global alphatag RC2
%global dotalphatag .%{alphatag}
%global dashalphatag -%{alphatag}

Name:       foreman-installer
Epoch:      1
Version:    1.5.0
Release:    0.6%{?dotalphatag}%{?dist}
Summary:    Puppet-based installer for The Foreman
Group:      Applications/System
License:    GPLv3+ and ASL 2.0
URL:        http://theforeman.org
Source0:    %{name}-%{version}%{?dashalphatag}.tar.gz

Patch1:     0001-Add-support-for-foreman-tasks.patch
Patch2:     0002-Use-forked-pl-apache-while-waiting-for-merge.patch
Patch3:     0003-Fix-missing-comma.patch
Patch4:     0004-Add-support-for-discovery-params-class.patch
Patch5:     0005-Depend-on-latest-kafo-and-curl.patch
Patch6:     puppet-foreman-0006-Add-support-for-foreman-tasks.patch
Patch7:     puppet-foreman-0007-We-download-and-install-discovery-images.patch
Patch8:     puppet-foreman-0008-Fix-TFTP-module-dependency.patch
# Patch 9 intentionally removed, obsoleted by patch 11
Patch10:    puppet-puppet-0010-Allow-custom-puppetmaster-value.patch
Patch11:    puppet-puppet-0011-Add-runmode-none-to-allow-for-masterless-Puppet-usag.patch
Patch12:    puppet-foreman_proxy-0012-Fixes-6751-convert-alias-VLAN-interface-names-to-fac.patch



%if 0%{?rhel} && 0%{?rhel} == 5
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%endif

BuildArch:  noarch

Requires:   curl
Requires:   %{?scl_prefix}puppet >= 2.7.0
Requires:   %{?scl_prefix}rubygem-kafo >= 0.5.3
Requires:   %{?scl_prefix}rubygem-foreman_api >= 0.1.4

%if %{?skip_generator:0}%{!?skip_generator:1}
%if 0%{?fedora} > 18
Requires:   %{?scl_prefix}ruby(release)
%else
Requires:   %{?scl_prefix}ruby(abi)
%endif
Requires:   %{?scl_prefix}rubygem-highline
%endif

BuildRequires: asciidoc
BuildRequires: rubygem(rake)
BuildRequires: %{?scl_prefix}puppet >= 2.7.0
BuildRequires: %{?scl_prefix}rubygem-kafo

%description
Complete installer for The Foreman life-cycle management system based on puppet and
script to generate answers for puppet manifests.

%prep
%setup -q -n %{name}-%{version}%{?dashalphatag}

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -d modules/foreman -p1
%patch7 -d modules/foreman -p1
%patch8 -d modules/foreman -p1
%patch10 -d modules/puppet -p1
%patch11 -d modules/puppet -p1
%patch12 -d modules/foreman_proxy -p1

%build
#replace shebangs for SCL
%if %{?scl:1}%{!?scl:0}
  sed -ri '1sX(/usr/bin/ruby|/usr/bin/env ruby)X%{scl_ruby}X' bin/foreman-installer
%endif
rake build \
  VERSION=%{version} \
  PREFIX=%{_prefix} \
  SBINDIR=%{_sbindir} \
  SYSCONFDIR=%{_sysconfdir} \
  --trace

%install
rake install \
  PREFIX=%{buildroot}%{_prefix} \
  SBINDIR=%{buildroot}%{_sbindir} \
  SYSCONFDIR=%{buildroot}%{_sysconfdir} \
  --trace

%if 0%{?rhel} && 0%{?rhel} == 5
%clean
%{__rm} -rf $RPM_BUILD_ROOT
%endif

%files
%defattr(-,root,root,-)
%doc README.* LICENSE
%config %attr(600, root, root) %{_sysconfdir}/foreman/%{name}.yaml
%config(noreplace) %attr(600, root, root) %{_sysconfdir}/foreman/%{name}-answers.yaml
%{_sbindir}/foreman-installer
%{_datadir}/%{name}
%{_mandir}/man8

%changelog
* Fri Jul 25 2014 Mike Burns <mburns@redhat.com> - 1.5.0-0.6.RC2
- cleanup patches around alias vlan interface names

* Thu Jul 24 2014 Mike Burns <mburns@redhat.com> - 1.5.0-0.5.RC2
- convert alias vlan interface names (mhulan@redhat.com)

* Mon Jun 02 2014 Mike Burns <mburns@redhat.com> - 1.5.0-0.4.RC2
- Update patch for runmode none

* Fri May 30 2014 Mike Burns <mburns@redhat.com> - 1.5.0-0.3.RC2
- puppet module add runmode none to allow for masterless puppet
- allow custom puppetmaster value

* Tue May 06 2014 Mike Burns <mburns@redhat.com> - 1.5.0-0.2.RC2
- update to 1.5.0-RC2
- add foreman tasks support
- use fored pl apache while waiting for merge
- add discovery params
- depend on latest kafo and curl

* Thu Jan 16 2014 Dominic Cleal <dcleal@redhat.com> - 1.5.0-0.develop
- Bump to version 1.5-develop

* Thu Nov 21 2013 Dominic Cleal <dcleal@redhat.com> - 1.4.0-0.develop
- Bump and change versioning scheme (#3712)

* Fri Nov 08 2013 Marek Hulan <mhulan[@]redhat.com> - 1.3.9999-4
- upgrade to kafo 0.3.0

* Thu Sep 12 2013 Marek Hulan <mhulan[@]redhat.com> - 1.3.9999-3
- set config flag on configuration files

* Thu Sep 12 2013 Marek Hulan <mhulan[@]redhat.com> - 1.3.9999-2
- config files packaging fix

* Wed Sep 11 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.3.9999-1
- bump to version 1.3-develop

* Mon Jul 22 2013 Marek Hulan <mhulan[@]redhat.com> - 1.2.9999-3
- new files structure for a installer based on kafo

* Mon Jul 22 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.2.9999-2
- adding foreman_api as a dependency

* Thu May 23 2013 Lukas Zapletal <lzap+rpm[@]redhat.com> - 1.2.9999-1
- initial version
